      SUBROUTINE STRDAY(ATOUT, C, CDAY, DQINT, DSOLRH, DTCR, DTIM1,
     + DTIM2, DTOB, DWHM, DWINT, DWSPED, ENDT, HDUM, HUMON, ICYCCP,
     + ICYC1, ICYC6, IDAYM, IDUM, INC, IREP, IRH, ISWING, KDAYM,
     + MPRINT, NROUT, NZONG, ODDBM, ODHUM, QBASVN, QHUMT, QSPT, QWAS,
     + RELHMI, RHDIR, RHIO, RODB, TBAS, TDIR, TDUM, TEMPDV, TIMAX,
     + TIMAXN, TIMIN, TIO, TONMAX, TRO, VENCRV, WATER, WSC, IDBG)
C  COMFTT REMOVED FROM FORMAL PAR LIST ABOVE TO SAVE MEMORY     
C
C-----START OF DAY LOOP
C
C-----CONSTANTS
CMDK CPAIR
CMDK BTUKWH
CMDK NHBK
CMDK NHRO
CMDK NHRP
CMDK NZN
CMDK NIWL
CMDK NKONST
CMDK NOUTDY
CMDK NWL
CMDK NWN
CMDK NZN7
CMDK NZW
CMDK RHOAIR      
C
C-----COMMON BLOCKS
CMDK ACHBQ
CMDK ACND
CMDK BAR
CMDK BLKCM2
CMDK BLK10
CMDK BLKFMT
CMDK BLKGS1
CMDK BLKGS2
CMDK BLKQGS
CMDK BLKQS
CMDK CNSTRK
CMDK DUCTS1
CMDK DUCTS2
CMDK DUCTS5
CMDK EBALA
CMDK ENCBLK
CMDK ENCBK1
CMDK ENCBK2
CMDK HANDBK
CMDK HUMIDC
CMDK INDIC1
CMDK IWETHR
CMDK IZZQ
CMDK LDPOUT
CMDK LPSTRB
CMDK MZON1
CMDK OUTPUT
CMDK OWETHR
CMDK QUAYCH
CMDK QUAYLE
CMDK SIMA
CMDK SOILB
CMDK SOLARB
CMDK STRUCA
CMDK SURFAR
CMDK TEMP1
CMDK TEMPB
CMDK TIMEB
CMDK TSTB2
CMDK TSTATC
CMDK WIBLK
      CHARACTER*8 CDAY (7)
      INTEGER J10(10),NDEV (3), NROUT(24)
      REAL ATOUT (12, 24), C(5),  DQINT(24)
      REAL DSOLRH(24), DTOB(24), DWHM(24), DWINT(24), DWSPED(24)
C     REAL COMFTT(11,21)
      CHARACTER*7 NL1
      CHARACTER*3 NL2
      REAL ODDBM(25), ODHUM(25), SLR(10)
C
C-----INITIALIZATIONS
      DATA NDEV   /0, 1, -1/
      DATA NL1/'SOLAR('/, NL2/')  '/
      DATA IDAY/0/
C
C
C-----EXTRACT SOLAR DATA AT BEGINNING OF EACH NEW DAY
      IDAY=IDAY+1
      CALL CURS(18)
      CALL SOLRLD(STM,NDYRI,ICC,KM,IDAY,DST,NSEQW,IDBG)
C
C  DATOUT(ISURF,ETC....)
C    ISURF=1,2  SOLAR ON ROOF ABOVE ATTICS 1 AND 2
C        3,4,...2+NROOMS  SOLAR IN WINDOWS OF ZONES 1,2,...NROOMS
C        2+NROOMS+1..... SOLAR ON OUTSIDE ENCLOSURE ELEMENTS
      IQQ2=NIJ
      IF(IQQ2.LT.1)IQQ2=1
      DO 252 ISURF=1, IQQ2
         DO 251 IHR=1, 24
            SOLAR (IHR, ISURF)=DATOUT (ISURF, IHR)
251         CONTINUE
         SOLAR (25, ISURF)=SOLAR (1, ISURF)
252   CONTINUE
      SOLARH (25)=SOLARH (1)
      IF (ISKIP.EQ.0 .AND. IGARAGT.GT.0) CALL GARAG (IGARAGT,NZONG,
     +                                               SOLARH(1))
      KDAYM=IDAYM
C
C     DTIME = DTIM1 (2 MIN) HERE
      DTIME=DTIM1
C     WETHR BLOCK 3
      IF (NSEQW.EQ.0 .OR. NSEQW.EQ.1) THEN
C--------CHECK FOR MEAN DAY CALC OR ADJUST NOMINAL DATA SET
C        USED ONLY WITH CARRIER DATA
         IF (IMEAN.LT.0) THEN
            DO 260 J=1, 25
               ODDB (J)=ODDBM (J)
260            CONTINUE
         ELSE
C-----------DETERMINE OUTDOOR TEMP PROFILE FOR MEAN, MAX, OR MIN DAY
C           CALCULATE WET BULB TEMPERATURE AND SPECIFIC HUMIDITY
C-----------FOR DATA FROM WEATHER FILE
            DO 280 J=1, 25
C--------------NDEV (1) = 0 DEVIATION FOR MEAN DAY CALCULATION
C--------------NDEV (2) = +1 DEVIATION FOR MAX  DAY CALCULATION
C--------------NDEV (3) = -1 DEVIATION FOR MIN  DAY CALCULATION
               ODDB (J)=ODDBM (J)+NDEV (IDAYM)*TEMPDV
               RODB=ODDB (J)
               ODWB=(((C (5)*ODDB (J)+C (4))*ODDB (J)+C (3))*
     1            ODDB (J)+C (2))*ODDB (J)+C (1)
C                   GET SPECIC HUMIDITY, WSC, USING PSY FUNCTIONS     
               PWSS=FPWS(ODWB)
               WSS=FW22(PWSS)
               WSC=FW35(RODB,ODWB,WSS)
               ODHUM (J)=WSC
280            CONTINUE
         END IF
      ELSE IF (NSEQW.EQ.3) THEN
         ODDB (1)=ODDB (25)
         WSPEED (1)=WSPEED (25)
         ODHUM (1)=ODHUM (25)
         KDAYM=KDY
         DO 285 IHR=2, 25
C 
C  ODDB  - OUTDOOR DRY-BULB TEMP, F
C  ODWB  - OUTDOOR WET-BULB TEMP, F
C  WSPEED- WIND SPEED, MILES/HR
C              PWSS BELOW IS A DUMMY VARIABLE         
            READ(41, *, IOSTAT=IO41) ODDB (IHR), ODWB, WSPEED (IHR),
     1         PWSS, PWSS, KMO, KDY, KHR
            IF(IO41.NE.0)THEN
              WRITE(60,*)' STRDAY: TROUBLE READING TAPE41!'
              STOP ' STRDAY: TROUBLE READING TAPE41!'
              ENDIF
            IF (IHR.LT.25 .AND. KMO.NE.KM) THEN
               WRITE(60, *) 'NSEQW=3 WEATHER OUT OF SEQUENCE',
     1         ' KMO,KM= ',   KMO, KM
               WRITE(*, *) 'NSEQW=3 WEATHER OUT OF SEQUENCE',
     1         ' KMO,KM= ',   KMO, KM
              
               STOP 'STRDAY: NSEQW=3 WEATHER OUT OF SEQUENCE'
            END IF
            RODB=ODDB (IHR)
C                   GET SPECIFIC HUMIDITY, WSC, USING PSY FUNCTIONS            
            PWSS=FPWS(ODWB)
            WSS=FW22(PWSS)
            WSC=FW35(RODB,ODWB,WSS)
            ODHUM (IHR)=WSC
285         CONTINUE
      END IF
      IF (NSEQW.EQ.0 .OR. NSEQW.EQ.1 .OR. NSEQW.EQ.3) THEN
         IF (INPRT.EQ.1) THEN
            WRITE(60, 2210) KM, CMONTH (KM),
     1         CDAY (IDAYM), WSHADE
            DO 300 IHR=1, 24
               WRITE(60, 2220) IHR, ODDB (IHR), ODHUM (IHR),
     1            (SOLAR (IHR, J), J=1, 6), QINTL (IHR), WINTL (IHR)
300            CONTINUE
            WRITE(60, *) 'SOLAR GAIN FOR WINDOWS WILL ',
     1         'BE MULTIPLIED BY THE WINDOW SHADE FACTOR, WSHADE=',
     2         WSHADE
         END IF
         TODAVG=0.
         DO 320 IHR=1, 24
            TODAVG=TODAVG+ODDB (IHR)
320         CONTINUE
         TODAVG=TODAVG/24.
C--------INTERPOLATE WEATHER DATA TO DESIRED TIME INCREMENTS
         DO 325 IHR=1, 24
            IHRP1=IHR+1
            DTOB (IHR)=(ODDB (IHRP1)-ODDB (IHR))*DTIME
            DWHM (IHR)=(ODHUM (IHRP1)-ODHUM (IHR))*DTIME
            DWSPED (IHR)=(WSPEED (IHRP1)-WSPEED (IHR))*DTIME
            DSOLRH (IHR)=(SOLARH (IHRP1)-SOLARH (IHR))*DTIME
325         CONTINUE
      END IF
      IF (INPRT.NE.0) THEN
        WRITE(60, *) 'HORIZONTAL SOLAR FOR TODAY:'
        WRITE(60, *) (IHR, SOLARH(IHR), IHR=1, 24)
      ENDIF
      IF (WSHADE.LT.1.0) THEN
C--------APPLY WINDOW SHADE FACTOR
         DO 330 IW=3,NROOMS+2
         DO 330 IHR=1, 25
            SOLAR (IHR,IW)=SOLAR (IHR,IW)*WSHADE
330         CONTINUE
      END IF
      IF (INPRT.NE.0 .AND. NSEQW.EQ.2) THEN
         WRITE(60, 2211) WSHADE, (IHR, (SOLAR (IHR, J), J=1, 6),
     1      QINTL (IHR), WINTL (IHR), IHR=1, 24)
          IF(NIJ.GT.6)THEN
              ISP=6
  332         IST=ISP+1
              ISP=ISP+10
              IF(ISP.GT.NIJ)ISP=NIJ
           WRITE(60,504)
           I=0
           DO 334 J=IST,ISP
           I=I+1
           J10(I)=J
  334      CONTINUE
           WRITE(60,500)(NL1,J10(IK),NL2,IK=1,I)
           DO 337 IHR=1,24
           I=0
           DO 336 J=IST,ISP
           I=I+1
           SLR(I)=SOLAR(IHR,J)
  336      CONTINUE
           WRITE(60,501)(SLR(IK),IK=1,I)
  337      CONTINUE
           IF(ISP.NE.NIJ)GO TO 332
           ENDIF
      END IF
C
      IF (TSOILF (IDAYM).EQ.999.0) THEN
         TODAG1=AFTG1*TODAVG+BFTG1
      ELSE
         TODAG1=TSOILF (IDAYM)
      END IF
      IF (TSOILW (IDAYM).EQ.999.0) THEN
         TODAG2=AWTG2*TODAVG+BWTG2
      ELSE
         TODAG2=TSOILW (IDAYM)
      END IF
      IF(IGRND.EQ.0)THEN
        DO 338 IQW=1,4
  338   TSOIL(IQW)=TODAG2
        TSOIL(5)=TODAG1
        TSOIL(11)=TODAG1
      ENDIF
      DO 340 IHR=1, 24
        DQINT (IHR)=(QINTL (IHR+1)-QINTL (IHR))*DTIME
        DWINT (IHR)=(WINTL (IHR+1)-WINTL (IHR))*DTIME
        DO 340 K=1, NIJ
          DSOLAR (IHR, K)=(SOLAR (IHR+1, K)-SOLAR (IHR, K))*DTIME
340   CONTINUE
C
C--------CAL MISC. CONSTANTS
      IF (ISKIP.EQ.0) THEN
        AIRMSB=ROMVOL(NZNBAS)*RHOAIR
        IF (IMODE.EQ.1) THEN
          TAIN=TBAS
          CALL ACOND (IDUM, TDUM, TDUM)
        END IF
C
C-----------START OF RUN CALCULATIONS
C-----------INITIALIZE VALUES
        TODDB=TODAVG+TOFFSET
        TGARAG=TODDB
        IF(IGARAGT.EQ.0.AND.NZONG.GT.0)TGARAG=.66*TODDB+.34*TI(1)
        NRDF1=0
C-----------SET INITIAL VALUES FOR DUCT MODEL
        TBAS=TBASI
        IF (TBAS.GT.200.0) TBAS=TI(1)
        TBASA=TBAS
        QFLBAS=0.0
        QBASVN=0.0
        TBASN=TBAS
        TCRW=(TODDB+TI(1))*.5*ICRW
        TCRWA=TCRW
        QFLCRW=0.0
        QCRWVN=0.0
        QGRND=0.0
        QVENTA=0.0
        TCRWN=TCRW
C-----------SET INITIAL VALUES FOR WALL AND ROOF MODELS
        TATTC(1)=(TI(1)+TODDB)*.5
        TATTA(1)=TATTC(1)
        TOTATC=(TODDB+TATTA(1))*.5
C  SET INITIAL TEMPS OF ROOF LAYERS
C   --COMMENTED INITIALIZATIONS WERE USED IN SINGLE-ZONE SP43 MODEL
        TMP(1,IZT+1)=TODDB
        TMP(2,IZT+1)=TOTATC
C        TMP(2,IZT+1)=TATTC(1)
        TMP(3,IZT+1)=TATTA(1)
C        TMP(3,IZT+1)=TATTC(1)
        TMP(4,IZT+1)=TATTA(1)
C        TMP(4,IZT+1)=TI(1)
        IF(NATC.EQ.2)THEN
          TMP(1,IZT+2)=TODDB
          TMP(2,IZT+2)=TOTATC
          TMP(3,IZT+2)=TATTA(1)
          TMP(4,IZT+2)=TATTA(1)
        ENDIF
C  SET INITIAL TEMPS OF ENCLOSURE ELEMENTS
        WRITE(60, 1000)
C
        DO 359 I=1,2
        QCEIL(I)=0.
        QRFSUM(I)=0.
 359    CONTINUE        
        DO 360 J=1,NROOMS
        NRM=NRMA(J)
        TFM(NRM)=TI(NRM)
        EBAL(NRM)=0.
        EBALT(NRM)=0.
        QLOSWL(NRM)=0.
        QLOSFL(NRM)=0.
C                            SET INITIAL TEMPS OF WALL AT THERMOSTAT
        TWSTAT(NRM)=TI(NRM)
        N2=NWALLA(NRM)
C
        DO 360 K2=1,N2
        IZW=NENC(NRM,K2)
        ID=IDEXP(IZW)
        NZONC=NZNC(IZW)
        NZON=NZONC-8
        KON=KONSTA(IZW)
        NLM=NLMP(KON)
        IF(ID.LE.4)THEN
C  OUTSIDE WALLS
          TODTI=(TODDB+TI(NRM))*0.5
          TMP(1,IZW)=TODDB
          TMP(2,IZW)=TODTI
          TMP(3,IZW)=TI(NRM)
          TMP(4,IZW)=TI(NRM)
        ENDIF
        IF(ID.EQ.5)THEN
C  CEILING
          IF(NZONC.EQ.4)IA=1
          IF(NZONC.EQ.5)IA=2
          IF(NZONC.LT.8)THEN
            TWALO=TATTA(IA)
            TMEAN=(TATTA(IA)+TI(NRM))*0.5
          ELSE
            TWALO=TI(NZON)
            TMEAN=(TI(NZON)+TI(NRM))*0.5
          ENDIF
          TMP(1,IZW)=TWALO
          TMP(2,IZW)=TMEAN
          TMP(3,IZW)=TI(NRM)
          TMP(4,IZW)=TI(NRM)
        ENDIF
        IF(ID.EQ.6)THEN
C  FLOOR
          IF(NZONC.EQ.2.OR.NZONC.EQ.7)THEN
C     LVG-SPC FLOOR W/ BSMT BELOW
            TBTI=(TBAS+TI(NRM))*.5
            TMP(1,IZW)=TBAS
            TMP(2,IZW)=TBTI
            TMP(3,IZW)=TI(NRM)
          ENDIF
          IF(NZONC.EQ.3.OR.NZONC.EQ.8)THEN
C    LVG-SPC FLOOR W/ CRAWL SPC BELOW
            TCTI=(TCRW+TI(NRM))*.5
            TMP(1,IZW)=TCRW
            TMP(2,IZW)=TCTI
            TMP(3,IZW)=TI(NRM)
          ENDIF
        ENDIF
        IF(ID.EQ.7)THEN
C  INTERIOR PARTION WALLS OR LVG SPC-GARAGE WALL
          TOUT=TI(NRM)
          IF(NZONC.EQ.6)THEN
            TOUT=TGARAG
          ELSE IF(NZON.GT.0)THEN
            TOUT=TI(NZON)
          ENDIF
          TMID=0.5*(TOUT+TI(NRM))
          TMP(1,IZW)=TOUT
          TMP(2,IZW)=TMID
          TMP(3,IZW)=TI(NRM)
          IF(NLM.NE.1)TMP(4,IZW)=TI(NRM)
          IF(IZW.EQ.20.OR.IZW.EQ.21.OR.IZW.EQ.25)THEN
            WRITE(60,*)' STRDAY: IZW,NRM,TMP(1,IZW)= ',IZW,NRM,
     +                 TMP(1,IZW)
            WRITE(60,*)'    TMP(2-4,IZW)= ',TMP(2,IZW),TMP(3,IZW),
     +                 TMP(4,IZW)
            WRITE(60,*)'    TGARAG,TI= ',TGARAG,TI(NRM)
          ENDIF
        ENDIF
        IF(ID.EQ.8)THEN
C                    BASEMENT FLOOR
          IF(IGRND.EQ.0)THEN
            TMID=0.5*(TODAG1+TBAS)
            TMP(1,IZW)=TODAG1
            TMP(2,IZW)=TMID
            TMP(3,IZW)=TBAS
            IF(NLM.NE.1)THEN
              TMP(3,IZW)=TMID
              TMP(4,IZW)=TBAS
            ENDIF
          ENDIF
        ENDIF
        IF(ID.EQ.9)THEN
C   BELOW-GROUND BSMT WALL
          IF(IGRND.EQ.0)THEN
            TMID=0.5*(TODAG2+TBAS)
            TMP(1,IZW)=TODAG2
            TMP(2,IZW)=TMID
            TMP(3,IZW)=TMID
            TMP(4,IZW)=TBAS
          ENDIF
        ENDIF
        IF(ID.EQ.10)THEN
C   ABOVE-GROUND BSMT WALL
          TINSID=.6*(TBAS-TODDB)+TODDB
          TMID=0.5*(TODDB+TINSID)
          TMP(1,IZW)=TODDB
          TMP(2,IZW)=TMID
          TMP(3,IZW)=TINSID
          IF(NLM.NE.1)THEN
            TMP(3,IZW)=TMID
            TMP(4,IZW)=TINSID
          ENDIF
        ENDIF
        WRITE(60,1010)NRM,IZW,ID,(TMP(I,IZW),I=1,4)
  360   CONTINUE
        WRITE(60,1014)(TMP(I,IZT+1),I=1,4)
        IF(NATC.EQ.2)WRITE(60,1016)(TMP(I,IZT+2),I=1,4)
        TRO=TODDB
C-----------DETERMINE INITIAL STATES OF ALL CONTROLS
        CALL TSTATD (3, IAC, IAC1, IBURN, IEFAN,IDBG)
C--------CALCULATE DUCT MODEL CONFIGURATION CONSTANTS
        DO 472 I=1, NZN7
        TZONE (I)=TI(1)
472     CONTINUE
        CALL DUCTIN(IDBG)
C            
        IF(IMODE.EQ.1.OR.(IMODE.EQ.2.AND.CFMBP.GT.0.))THEN
C   SET INITIAL ABSOLUTE HUMIDITY IN ZONES
          TIM=AVGWV(TI,NROOMS,RWSDCT)
          IPSY=-3
          CALL PSY (IPSY, TIM, TDUM, TDUM, RELHMI,WIM, HDUM)
        ELSE
          WIM=.01
        ENDIF
        DO 361 JT=1,NROOMS
        IPSY= -3
        CALL PSY(IPSY,TI(JT),TDUM,TDUM,RELHMI,WI(JT),HDUM)
  361   CONTINUE        
        RHI=RELHMI
        RHS=RHI
        RHSN=RHI
        TIO=TI(1)
        RHIO=RHI
        WBAS=WI(NZNBAS)
        WBASN=WBAS
        WAC=WIM
        TPL=TI(1)
C----------SET HUMIDIFIER STATES  
        IF(IMODE.EQ.2.AND.CFMBP.GT.0.)CALL HUMDF1 (TI(1))
        FINFB=0.
        TDIR=1.
        IF (IBURN.EQ.1) TDIR=-1.
        RHDIR=100.
        IF (IBURN.EQ.1) RHDIR=-100.
C--------GO THRU NDPRE DAYS BEFORE TAKING DATA (ONLY ONCE WITH SEQ WTHR)
        IF (NSEQW.EQ.0) IREP=0
      END IF
C  * * * * *    END OF MISC CONSTANTS CALCULATION  (W/ ISKIP = 0)
C-----INITIALIZE COUNTERS TO ZERO
C      DO 431 J=1, 21
C         DO 430 I=1, 11
C            COMFTT (I, J)=0.
C 430         CONTINUE
C 431      CONTINUE
      DO 453 IHR=1, 24
         NROUT (IHR)=0
         DO 440 J=1, 12
            ATOUT (J, IHR)=0.
440         CONTINUE
      DO 441 J=1,3
      HROT(J,IHR)=0.
      HPRT(J,IHR)=0.
441   CONTINUE
         DO 450 J=1, NHRP
            HRPRT (J, IHR)=0.
450         CONTINUE
         DO 451 J=1, NHRO
            HROUT (J, IHR)=0.
451         CONTINUE
453      CONTINUE
      DO 452 I=1, NHBK
         HBK (I)=0.0
452      CONTINUE
      IHUM=(1.-.0001*(RHS-SETHS))
      IF (CFMBP.LE.0.0) IHUM=0
      WATER=0.0
      QSPT=0.0
      QWAS=0.0
      QHUMT=0.0
      HUMON=0.0
      ICYCCP=0
      ICYC1=0
      ICYC6=0
      CLOSE(11)
      OPEN(11,FILE='TAPE11',STATUS='UNKNOWN')
      ISWING=0
      CLOSE(1)
      OPEN(1,FILE='TAPE1',STATUS='UNKNOWN')
      IRH=0
      INC=0
      LINES=0
      TONMAX=0.0
      TIMAX=0.0
      TIMAXN=0.0
      TIMIN=999.0
      MPRINT=1
      IF (NINC.EQ.0) MPRINT=0
      IF ((MPRINT.NE.0) .OR. (IDEBUG.GT.0)) WRITE(60, 2270)
      IF (ISKIP.EQ.0) THEN
         VENCRV=VENCRW*VOLCRW*CPAIR
         DTCR=0.
         IF (ICRW.EQ.1) DTCR=DTIM2/(CPAIR*VOLCRW)
      END IF
C-----CHANGE TIME INCREMENT TO INNER LOOP VALUE
      DTIME=DTIM2
      IF (ISKIP.EQ.0) THEN
C
         TWRT=TBAS
         TWRTB=TBAS
         TWSP=TBAS
         TWSPB=TBAS
C
C--------CALC TIME CONST VALUES
         CALL TSTATD (4, IAC, IAC1, IBURN, IEFAN, IDBG)
         TCRH=0.0
         IF (CFMBP.GT.0.0) TCRH=DTIME/HSTC
         ENDT=HRDY - .5*DTIME
      END IF
      RETURN
C
  500 FORMAT(1X,10(A7,I2,A3))
  501 FORMAT(1X,(10F12.4))
  504 FORMAT(1X///)
1000  FORMAT (/' INITIAL STRUCTURE TEMPERATURES...')
1010  FORMAT (1X,'NRM,IZW,ID= ',3I5,' NODE TEMPS(1-4)= ',4G13.5)
 1014 FORMAT(15X,'ROOF TEMPS(ATTIC NO 1)= ',4G13.5)
 1016 FORMAT(15X,'ROOF TEMPS(ATTIC NO 2)= ',4G13.5)
1020  FORMAT (' ERROR...DUPLICATE GARAGE MODELS SPECIFIED')
C-----INPUT DATA PRINTING
2210  FORMAT (///'  WEATHER DATA FOR MONTH', I3, '=', A3, 5X, A8,
     1   ' (WSHADE=', F5.2, ')', //,
     2   30X, 4 ('WALL', 8X), 'ROOF', 8X, 'WINDOW', /,
     3   ' HOUR DRY BULB    HUMIDITY    SOLAR(1)    SOLAR(2)    ',
     4   'SOLAR(3)    SOLAR(4)    SOLAR(5)    SOLAR(6)    SEN. LOAD   ',
     5   'LAT. LOAD', /)
2211  FORMAT (/' SOLAR DATA AND INTERNAL LOADS. (WSHADE=', F5.2, ')', //
     1   8X, 'SOLAR(1)    SOLAR(2)    SOLAR(3)    ',
     2   'SOLAR(4)    SOLAR(5)    SOLAR(6)    SEN. LOAD   LAT. LOAD', /,
     3   (I4, 1X, 8G12.4))
C 2212 FORMAT(/' SOLAR(',I2,')   SOLAR(',I2,')  SOLAR(',I2,')  SOLAR(',
C    +I2,')   SOLAR(',I2,')  SOLAR(',I2,')   SOLAR(',I2,')  SOLAR(',
C    +I2,')   SOLAR(',I2,')'/(2X,10G12.4))
2220  FORMAT (I4, 1X, 10G12.4)
C-----ITERATION PRINTING
2270  FORMAT (/// T6, 'TIME', T15, 'TODDB', T28, 'TI(1)', T37, 'RHI',
     1   T48, 'TPL', T56, 'TSUP', T65, 'TRETB', T76, 'TBAS', T85,
     2   'TATTC', T95, 'TFLUE', 3X, 'IAC IBURN IBLOW IHON EXCESS', //)
      END
