C      PROGRAM ASHLST(INPUT,OUTPUT,TAPE5=INPUT,TAPE6=OUTPUT, 
C     +TAPE1,TAPE2,TAPE3)
C  LIST DATA FROM CONVERTED DATA FILE (MAX OF 9 CHANNELS PER PASS)
      DIMENSION A(150),NCH(11),Y(11),Y3(11),NCH3(11)
      NAMELIST/INPUTS/NTSKP,NTS,NCRV,NCH,NFORM,TIMYRI,TIMSTP
     +,NCH3,NTAPE3,TIME0,NRANGE,TIMCON,ITIME0
C  NTSKP = NO. OF DATA SETS TO SKIP(EA SET OF DATA WITH TIME IS A SET)
C    NTS = NO. OF POINTS OF EACH DATA CHANNEL TO LIST ON TAPE2
C  NCRV = NO. OF DATA CHANNELS TO LIST
C   NCH = DATA CHANNEL NUMBERS (MAX OF 11 FOR EACH PASS, SAME #'S AS FOR CDATA
C         INDICES.
C NFORM = FORMAT INDICATOR (NOT YET USED)
C TIMYRI = TIME OF YEAR AT START OF DATA TO EXTRACT, HR
C TIMSTP = TIME OF YEAR AT STOP OF DATA TO EXTRACT, HR
C NTAPE3 = NO. OF DATA POINTS TO LIST ON TAPE3
C NCH3  SAME AS NCH BUT FOR A 2ND FILE ON TAPE3
C TIME0  = STARTING TIME TO SUBTRACT FROM TIME OF YEAR SO VALUES START FROM 0.
C NRANGE = SEE CODE BELOW FOR FUNCTION
C  TIMCON = 1.  TIME UNCONVERTED
C         = 60. TIME IN MINUTES
C ITIME0 = SEE CODE BELOW FOR FUNCTION
      OPEN(1,FILE='TAPE1',STATUS='OLD') 
      OPEN(2,FILE='TAPE2',STATUS='NEW')
      OPEN(5,FILE='TAPE5',STATUS='OLD')
      OPEN(6,FILE='TAPE6',STATUS='NEW')
      DATA NRANGE/1/
      DATA NTAPE3/0/
      DATA TIMSTP/0./
      DATA TIME0,NTSKP/0.,0/
      DATA ITIME0,TIMCON/1,1./
  200 READ(5,INPUTS,END=199)
      GO TO 210
  199 CLOSE(1)
      CLOSE(2)
      IF(NTAPE3.NE.0)CLOSE(3)
      STOP ' ENDED ON EOF ON TAPE 5, OKAY??'
  210 IFILE=1
      WRITE(6,INPUTS)
      IF(NTAPE3.NE.0)OPEN(3,FILE='TAPE3',STATUS='NEW')
      NEND=0
      ASSIGN 298 TO ILST
      ASSIGN 4 TO IRTN
      IF(NTSKP.EQ.0)GO TO 4
      ASSIGN 99 TO ILST
      ASSIGN 1 TO IRTN
      DO 2 IJ=1,NTSKP
    1 READ(1,1010,IOSTAT=IO,END=3)TIME, 
     +NDAY,NHR,NMIN,NSEC,NDSEC,IC,IYEAR,
     +(A(I),I=2,IC) 
      CALL ERTRAP(IFILE,IO,IEND)
      IF(IEND.EQ.1)GO TO 3
      NEND=0
    2 CONTINUE
      GO TO 11
    3 NEND=NEND+1
      CLOSE(1)
      OPEN(1)
      IF(NEND.GT.2)GO TO ILST(99,298,98)
      GO TO IRTN(1,4,13)
C  ASSUME START AT TIMYRI
    4 READ(1,1010,IOSTAT=IO,END=3)TIME, 
     +NDAY,NHR,NMIN,NSEC,NDSEC,IC,IYEAR,
     +(A(I),I=2,IC) 
      CALL ERTRAP(IFILE,IO,IEND)
      IF(IEND.EQ.1)GO TO 3
      NEND=0
      IF(TIME.LT.TIMYRI)GO TO 4
   11 ND=0
      ASSIGN 98 TO ILST
      ASSIGN 13 TO IRTN
      WRITE(6,504)(NCH(I),I=1,NCRV)
      WRITE(2,504)(NCH(I),I=1,NCRV)
      IF(NTAPE3.NE.0)WRITE(3,504)(NCH3(I),I=1,NTAPE3)
   12 NEND=0
   13 READ(1,1010,IOSTAT=IO,END=3)TIME, 
     +NDAY,NHR,NMIN,NSEC,NDSEC,IC,IYEAR,
     +(A(I),I=2,IC) 
      CALL ERTRAP(IFILE,IO,IEND)
      IF(IEND.EQ.1)GO TO 3
      NEND=0
      IF(ND.EQ.0)THEN
          IF(ITIME0.EQ.0)TIME0=TIME*TIMCON
          IF(ITIME0.LT.0)TIME0=TIMYRI*TIMCON
          WRITE(6,532)TIME
  532     FORMAT(1H0,' FIRST TIME IS ',F12.5,' HR')
          ENDIF
      ND=ND+1
      TIM=TIME*TIMCON-TIME0
      IDAT=0
      DO 21 J=1,NCRV
      IQ=NCH(J)
      IF(IC.GT.9)GO TO 20
      IF(IQ.LE.9)GO TO 20
      Y(J)=0.
      GO TO 21
   20 AIQ=A(IQ)
      IF(AIQ.LT.(-1.E+30))IDAT=1
      IF(AIQ.GT.1.E+30)IDAT=1 
      Y(J)=AIQ
   21 CONTINUE
      IF(NTAPE3.EQ.0)GO TO 24 
      DO 23 J=1,NTAPE3
      IQ=NCH3(J)
      IF(IC.GT.9)GO TO 22
      IF(IQ.LE.9)GO TO 22
      Y3(J)=0.
      GO TO 23
   22 AIQ=A(IQ)
      IF(AIQ.LT.(-1.E+30))IDAT=1
      IF(AIQ.GT.1.E+30)IDAT=1 
      Y3(J)=AIQ
   23 CONTINUE
   24 IF(IDAT.EQ.1.AND.NRANGE.EQ.1)THEN 
          ND=ND-1
          GO TO 25
          ENDIF
      WRITE(2,501)TIM,(Y(I),I=1,NCRV)
      IF(NTAPE3.NE.0)WRITE(3,501)TIM,(Y3(I),I=1,NTAPE3)
   25 IF(TIMSTP.GT.0.)GO TO 97
      IF(ND.EQ.NTS)GO TO 98
      GO TO 12
   97 IF(TIME.GT.TIMSTP)GO TO 98
      GO TO 12
   98 WRITE(6,503)ND,TIME
      GO TO 200
   99 WRITE(6,500)
      CLOSE(1)
      CLOSE(2)
      IF(NTAPE3.NE.0)CLOSE(3)
      STOP 'ENDED ON EOF , OKAY??!!'
  298 WRITE(6,505)
      CLOSE(1)
      STOP
  500 FORMAT(1X,'----OOPS,EOF ON TAPE1 WHEN SKIPPING TO FIND DATA')
  501 FORMAT((1X,F12.5,11(1X,E10.4)))
  503 FORMAT(1X,'NO OF DATA POINTS LISTED = ',I5,' LAST TIME= ',F12.5)
  504 FORMAT(1X,'TIME,HR',2X,11(4X,I3,4X))
  505 FORMAT(1X,'---OOPS,EOF ON TAPE1 WHEN FINDING TIMYRI') 
 1010 FORMAT(F12.5,I4,5I3,I5/(8E10.4))
      END 
      SUBROUTINE ERTRAP(IFILE,IO,IEND)
C
C  ERROR TRAP ROUTINE FOR READING CONVERTED DATA FILE
      CHARACTER DP*1
      IEND=0
      NEND=0
      IF(IO.EQ.0)GO TO 20
    5     READ(IFILE,'(6X,A1)',END=10)DP
          IF(DP.EQ.'.')THEN
                 BACKSPACE IFILE
                 GO TO 20
                 ENDIF
          GO TO 5
   10 NEND=NEND+1
      CLOSE(IFILE)
      OPEN(IFILE)
      IF(NEND.GT.2)GO TO 30
      GO TO 5
   20 CONTINUE
      RETURN
   30 WRITE(6,500)
  500 FORMAT(1X,'HIT END OF FILE WHEN TRYING TO FIND GOOD DATA')
      IEND=1
      GO TO 20
      END 
