C      PROGRAM CYC(INPUT,OUTPUT,TAPE5=INPUT,TAPE6=OUTPUT)
C   CYC PROGRAM
C  CHECK CYCLING RATE OF FURNACE 
C  PREDICTED FILE OF GAS VALVE CYCLES (TAPE51) SHOULD BE EDITED FOR 
C  STARTING AND STOPPING TIME AND ANY GAPS TO AGREE W/ EXPERIMENTAL DATA
C  THIS EDITED VERSION OF TAPE51 WILL GET COPYIED TO FILE CYCDAT.  NOTE
C  THAT TAPE51 IS ACTIVATED BY SETTING IEVPRT=1 IN FILE FUR1AH1A.DAT
      DIMENSION TGAP(10,2),IBRN(3)
      CHARACTER*10,NHEAD(8)
      OPEN(4,FILE='CYCDATA',STATUS='OLD')
      OPEN(5,FILE='CYCDAT',STATUS='OLD')
      OPEN(2,FILE='CYC.OUT',STATUS='NEW')
      ICY2=0
      ICY3=0
      ICY35=0
      ICY4=0
      ICY45=0
      ICY5=0
      ICY55=0
      ICY6=0
      ICY7=0
      ICY8=0
      ICY10=0
      ICY12=0
      ICY14=0
      ICY16=0
      ICY18=0
      ICY20=0
      ICY100=0
      TMONQ=0.
      TMOFQ=0.
      NHLIM=0
C    ITYP = 1  MEASURED DATA
C    ITYP = 2  PREDICTED DATA 
C    IPR =0 TO ELIM PRINT OF EVERY CYCLE
C    IPR > 0, PRINT IPR VALUES OF CYCPHR,ETC
C    NGAP = NO. OF GAPS IN DATA
C    TGAP = TIME AT START AND END OF GAP, HR
  10  READ(4,522,END=999)NHEAD
      WRITE(2,523)NHEAD
      READ(4,*,END=999)ITYP,IPR,TMSTRT,TMSTOP
      WRITE(2,*)'ITYP,IPR= ',ITYP,IPR
      READ(4,*)NGAP 
      IF(NGAP.GT.0)THEN
         READ(4,*)((TGAP(I,J),J=1,2),I=1,NGAP)
         DO 11 I=1,NGAP
  11     WRITE(2,508)(TGAP(I,J),J=1,2)
         ENDIF
      ICODLS=1
      NCYC=0
      IQ=0
      IPT=0
      DATA IQFIX/1/
   20   IF(ITYP.EQ.1)THEN
C  MEASURED DATA
         READ(5,*,END=999)TIMEHR,NDY,NHR,NMN,NSC,NDSC,ICODE,IYR,
     +                      (IBRN(I),I=1,3)
C  ICODE CAN BE 1 WHEN IBRN > 0 DUE TO HIGH LIMIT OPERATION       
         IF(IQFIX.EQ.1)THEN
            ICODQ=ICODE
            ICODE=1 
            DO 22 I=1,3
  22        IF(IBRN(I).NE.0)ICODE=2
            IF(ICODQ.EQ.1.AND.ICODE.EQ.2)THEN
C              WRITE(2,509)ICODQ,ICODE,(IBRN(I),I=1,3)
              NHLIM=NHLIM+1
              ENDIF
            ICODE = ICODQ
            ENDIF
      ELSE
C  PREDICTED DATA
         READ(5,*,END=999)TIMEHR,NDY,NHR,NMN,NSC,NDSC,ICODE,
     +                    (IBRN(I),I=1,3)
C  ICODE CAN BE 1 WHEN IBRN > 0 DUE TO HIGH LIMIT OPERATION       
         IF(IQFIX.EQ.1)THEN
            ICODQ=ICODE
            ICODE=1 
            DO 220 I=1,3
  220       IF(IBRN(I).NE.0)ICODE=2
            IF(ICODQ.EQ.1.AND.ICODE.EQ.2)THEN
C              WRITE(2,509)ICODQ,ICODE,(IBRN(I),I=1,3)
              NHLIM=NHLIM+1
              ENDIF
            ICODE = ICODQ
            ENDIF
         ENDIF
  23  IF(IQ.EQ.0.AND.ICODE.EQ.2)THEN
C    FIRST TIME THROUGH OR AFTER A GAP
         IQ=1
         TIMELS=TIMEHR
         WRITE(2,510)ICODE,TIMEHR
         ICODLS=ICODE
          IF(NGP.EQ.1)THEN
            NGP=0
            GO TO 20
            ENDIF
         ENDIF
      NGP=0
      IF(ICODLS.EQ.1.AND.ICODE.EQ.2)THEN
C   BURNER CAME ON
         NCYC=NCYC+1
         TIMEOF=TIMEHR-TIMELS 
         TMQOF=TIMEHR
         TMOFQ=TMOFQ+TIMEOF
         TCYC=TIMEON+TIMEOF
         PCTON=100.*TIMEON/TCYC
         CYCPHR=1./TCYC
         TMEON=TIMEON*60.
         TMEOF=TIMEOF*60.
         IF(IPR.NE.0)THEN
            IPT=IPT+1
            IF(IPT.LE.IPR.AND.TIMEHR.GT.TMSTRT)WRITE(2,502)NCYC
     +               , TIMEHR,TMEON,TMEOF,PCTON,CYCPHR
            ENDIF
C  IF AT GAP, SKIP SORTING INTO BINS
         IF(NGAP.NE.0)THEN
            DO 30 I=1,NGAP
            NGP1=0
            IF(TMQON.GT.TGAP(I,1).AND.TMQON.LT.TGAP(I,2))NGP1=1
            IF(TMQOF.GT.TGAP(I,1).AND.TMQOF.LT.TGAP(I,2))NGP1=1
             IF(TMQON.LT.TGAP(I,1).AND.TMQOF.GT.TGAP(I,2))NGP1=1
            TMGAP=0.5*(TGAP(I,1)+TGAP(I,2))
            IF(TMQON.LE.TMGAP.AND.TMQOF.GE.TMGAP)NGP1=1
            IF(NGP1.EQ.1)THEN 
               WRITE(2,505)TGAP(I,1)
               IQ=0 
               NGP=1
               NCYC=NCYC-1
               TMOFQ=TMOFQ-TIMEOF
               TMONQ=TMONQ-TIMEON
               GO TO 23
               ENDIF
   30    CONTINUE
            ENDIF
         IF(CYCPHR.GT.20.)THEN
            ICY100=ICY100+1
         ELSE IF (CYCPHR.GT.18..AND.CYCPHR.LE.20.)THEN
            ICY20=ICY20+1
         ELSE IF (CYCPHR.GT.16..AND.CYCPHR.LE.18.)THEN
            ICY18=ICY18+1
         ELSE IF (CYCPHR.GT.14..AND.CYCPHR.LE.16.)THEN
            ICY16=ICY16+1
         ELSE IF (CYCPHR.GT.12..AND.CYCPHR.LE.14.)THEN
            ICY14=ICY14+1
         ELSE IF (CYCPHR.GT.10..AND.CYCPHR.LE.12.)THEN
            ICY12=ICY12+1
         ELSE IF (CYCPHR.GT.8..AND.CYCPHR.LE.10.)THEN
            ICY10=ICY10+1
         ELSE IF (CYCPHR.GT.7..AND.CYCPHR.LE.8.)THEN
            ICY8=ICY8+1
         ELSE IF (CYCPHR.GT.6..AND.CYCPHR.LE.7.)THEN
            ICY7=ICY7+1
         ELSE IF (CYCPHR.GT.5.5.AND.CYCPHR.LE.6.)THEN
            ICY6=ICY6+1
         ELSE IF (CYCPHR.GT.5..AND.CYCPHR.LE.5.5)THEN
            ICY55=ICY55+1
         ELSE IF (CYCPHR.GT.4.5.AND.CYCPHR.LE.5.)THEN
            ICY5=ICY5+1
         ELSE IF (CYCPHR.GT.4..AND.CYCPHR.LE.4.5)THEN
            ICY45=ICY45+1
         ELSE IF (CYCPHR.GT.3.5.AND.CYCPHR.LE.4.)THEN
            ICY4=ICY4+1
         ELSE IF (CYCPHR.GT.3..AND.CYCPHR.LE.3.5)THEN
            ICY35=ICY35+1
         ELSE IF (CYCPHR.GT.2..AND.CYCPHR.LE.3.)THEN
            ICY3=ICY3+1
         ELSE IF (CYCPHR.GT.0..AND.CYCPHR.LE.2.)THEN
            ICY2=ICY2+1
            ENDIF
         TIMELS=TIMEHR
         ICODLS=ICODE
         GO TO 20
         ENDIF
      IF(ICODLS.EQ.2.AND.ICODE.EQ.1)THEN
C  BURNER WENT OFF
         TIMEON=TIMEHR-TIMELS 
         TMQON=TIMELS
         TMONQ=TMONQ+TIMEON
         TIMELS=TIMEHR
         ICODLS=ICODE
         IF(NGP.EQ.1)WRITE(2,506)TIMEHR 
         GO TO 20
         ENDIF
      GO TO 20
  999 CONTINUE
      ICYT=ICY2+ICY3+ICY35+ICY4+ICY45+ICY5+ICY55+ICY6+ICY7+ICY8
     ++ICY10+ICY12+ICY14+ICY16+ICY18+ICY20+ICY100 
      WRITE(2,504)ICY2,ICY3,ICY35,ICY4,ICY45,ICY5,ICY55,ICY6,ICY7,
     +        ICY8,ICY10,ICY12,ICY14,ICY16,ICY18,ICY20,ICY100,
     +        NCYC,ICYT
      DENOM = TMOFQ + TMONQ
      IF(DENOM.NE.0.)THEN
        PCTONA=100.*TMONQ/(TMOFQ+TMONQ)
      ELSE
        PCTONA = 0.
        ENDIF
      WRITE(2,507)PCTONA,TMONQ,TMOFQ
      WRITE(2,503)NHLIM
      STOP 'ENDED OK!!!!'
  500 FORMAT(F12.0,18X,I1,7X,I1,2X,I1,2X,I1)
  501 FORMAT(F12.0,18X,I1,3X,3I2)
  502 FORMAT(1X,'TIMHR,ON,OFF(MIN),PCTON,CYCPHR= ',I5,F12.4,4F6.2)
  503 FORMAT(2X,' NO. OF HIGH LIMIT CYCLES= ',I5)
  504 FORMAT(1X,'FREQUENCY IN BINS OF CYCLES PER HOUR'/
     +5X,'BIN 0. TO 2. CPHR  ',I6/
     +5X,'BIN 2. TO 3. CPHR  ',I6/
     +5X,'BIN 3. TO 3.5 CPHR ',I6/
     +5X,'BIN 3.5 TO 4. CPHR ',I6/
     +5X,'BIN 4. TO 4.5 CPHR ',I6/
     +5X,'BIN 4.5 TO 5. CPHR ',I6/
     +5X,'BIN 5. TO 5.5 CPHR ',I6/
     +5X,'BIN 5.5 TO 6. CPHR ',I6/
     +5X,'BIN 6. TO 7. CPHR  ',I6/
     +5X,'BIN 7. TO 8. CPHR  ',I6/
     +5X,'BIN 8. TO 10. CPHR ',I6/
     +5X,'BIN 10. TO 12. CPHR',I6/
     +5X,'BIN 12. TO 14. CPHR',I6/
     +5X,'BIN 14. TO 16. CPHR',I6/
     +5X,'BIN 16. TO 18. CPHR',I6/
     +5X,'BIN 18. TO 20. CPHR',I6/
     +5X,'BIN >20. CPHR      ',I6/
     +5X,'****TOTAL NO. OF CYCLES= ',I6/
     +5X,'**NO. OF BINNED CYCLES=  ',I6)
  505 FORMAT(1X,'NO SORTING AT A GAP AT TIME= ',F12.4)
  506 FORMAT(1X,'OOPS!!! BURNER WENT OFF AT END OF GAP AT TIME= ',
     +G13.5)
  507 FORMAT(1X,'AVG PCT ON-TIME= ',G13.5/
     +       1X,'TOTAL ON TIME= ',G13.5,' HR'/
     +       1X,'TOTAL OFF TIME= ',G13.5,' HR')
  508 FORMAT(1X,'GAPS AT TIME = ',F12.4,2X,F12.4)
  509 FORMAT(1X,'ICODE RESET FROM ',I3,'  TO ',I3,'  IBRN(1-3)= ',3I5)
  510 FORMAT(1X,'ICODE,TIMEHR(1ST)= ',I3,2X,F12.4)
  511 FORMAT(1X,'TMQON,TMQOF,TGAP(1,2),NGP1= ',4F12.4,I3)
  522 FORMAT(8A10)
  523 FORMAT(1X,8A10)
      END 
