REM -- RUNTCYC.BAT FILE--
REM  RUN TCYC TO GET THERMOSTAT CYCLING CHARACTERISTICS IN EACH ZONE
REM  RUN EX:  RUNTCYC CYC1208 H1A TAPE3A 1   
REM   PARAMETERS:  %1  INPUT DATA FILE USED WITH CYC.FOR: %1.DAT
REM                %2  RUN ID AND SUBDIRECTORY WHERE EVENT DATA FILE RESIDES
REM                    (I.E. SUBDIRECTORY  \HII\DAT\%2)
REM                %3  TI/EVENT DATA FILE  (I.E. FILE \HII\DAT\%2\%3)
REM                %4  IDAMP =0 FOR EXP; =1 FOR 1ST PRED RUN; = 0 FOR FINAL
REM                    PREDICTED RUN
REM   INPUT DATA FILES:   %1.DAT    CYC.FOR INPUT DATA FILE
REM                       C:\HII\DAT\%2\%3   TI/EVENT FILE
REM   FOR PREDICTED FILES, THE DATA SHOULD BE RUN TWICE
REM       1ST RUN WILL BE WITH IDAMP IN TCYC CONTROL FILE = 1 TO USE 
REM       DAMPER EVENTS. FIND AND PRINT SCREEN THE VALUES OF ON-TIME IN
REM       EACH ZONE.   2ND RUN WILL BE WITH IAMAP = 0 TO USE THERMOSTAT
REM       EVENTS(DATA WILL BE STORED IN C:\HII\DAT\%2)
REM                                        
DEL TCY1.OUT
DEL TCY2.OUT
DEL TCY3.OUT
DEL TCYC.OUT
DEL CYCDATA
DEL EVTIS.DAT
DEL TCYC.DAT
COPY %1.DAT CYCDATA
COPY C:\HII\DAT\%2\%3 EVTIS.DAT
DEL TCYC.DAT
ECHO %4 > TCYC.DAT
TCYC
COPY TCY1.OUT C:\HII\DAT\%2\TS1%2.OUT
COPY TCY2.OUT C:\HII\DAT\%2\TS2%2.OUT
COPY TCY3.OUT C:\HII\DAT\%2\TS3%2.OUT
REM COPY CYCDATA+TCYC.DAT+TCYC.OUT C:\HII\DAT\%2\TCY%2.OUT
REM                C:\HII\DAT\%2\TCY%2.OUT  TCYC GENERAL OUTPUT FILE
DEL TCY1.OUT
DEL TCY2.OUT
DEL TCY3.OUT
DEL CYCDATA
DEL EVTIS.DAT
DEL TCYC.DAT
REM  OUTPUT FILES: C:\HII\DAT\%2\TS1%2.OUT  TSTAT CYCLING CHARACTERISTICS FOR ZONE
REM                             1 THERMOSTAT
REM                C:\HII\DAT\%2\TS2%2 OUT  LIKEWISE FOR ZONE 2
REM                C:\HII\DAT\%2\TS3%2 OUT  LIKEWISE FOR ZONE 3
REM     LOCAL COPY OF GENERAL OUTPUT FILE IS ON TCYC.OUT
REM  NOTE: LIST TCYC.OUT AND PRINT LAST SCREEN!

