C *** CALIBRATE GAS FURNACE MODEL--GASF
CMDK NZN
CMDK RHOAIR
      DIMENSION QNMHX(3),QNMSV(5)
      CHARACTER*4 NCTQ(4),NCTR
CMDK AFUE      
      COMMON/AFUE1/TFON1,TFON2,TFSS,TFOFF3,TFOFF4,TFOFF5,DTRA2,WFCT(9)
      COMMON/BLK8/IPLT,QUSE(300),QINP(300),QSLOS(300),QLLOS(300)
      COMMON/BLK9/TT(300)
CMDK BLK10      
      COMMON/BLK20/ZT(300),IPLOT,XT(300),YT(300)
      COMMON/BLK37/TOLYR,DSPMIN
CMDK BLK81      
CMDK BLK83
CMDK BLK85
CMDK BLK87
      COMMON/BLK88/QMHXT(300,3),QACLT(300),QMPLT(300),QMSVT(300,5)
     +,QMJT(300)
CMDK BLKCM1
CMDK BLKCM2
      COMMON/BLKDBG/QNMIN,QNMOT
CMDK BLKGS1
CMDK BLKGS2
CMDK BLKOIL
CMDK BLKQGS
CMDK BLKQHX      
      COMMON/BLKSM/X(15),Y
      COMMON/BLKWHM/WAIRHM,QCBAIR
CMDK COLCT      
CMDK DTRQ
CMDK FANBLK
CMDK FUEL1
CMDK GASFC
CMDK HUMIDC
CMDK INDIC1
      COMMON/INDQB/INDQ(5)
CMDK MZON1
CMDK OILB      
CMDK PRT1
CMDK TEMP1
CMDK TIMEB
C         TI MUST BE 5 VALUES!
C         TATTC MUST BE 2 VALUES     
      NAMELIST/INPUT/TIMEON,TIMEOF,TCYCON,ISKIP,IDEBUG,
     +ICOND,NCYCLS,RELH,
     +TRETP,WSPED,TI,TODDB,TATTC,TAIN,TWBI,TCOMB,BARPSI,
     +TIME1,TIME3,
     +TRAREF,TMSV,TJSV,TMACSV,TMPLSV,TMV,
     +NSK1,NSK2,NSK3,IAFUE,IQFILE,INDQ
C  TWBI  WET BULB TEMP OF COMB AIR, F
C  RELH  RELATIVE HUMIDITY OF COMB AIR, PCT
C  ICOND  = 1 FOR CONDENSING DIRECT VENT FURNACE
C  NCYCLS  IS NO OF CYCLES TO RUN FOR EACH POINT, INCLUDING FINAL CYCLE
C  IAFUE = 1 FOR AFUE CYCLE ALSO
C  IQFILE = 1 FOR QFILES WRITTEN TO TAPES 2 AND 3
C  NSK1-4 ARE NO OF STMTS TO SKIP IN READING TAPE5 INPUT DATA
C     FOR LOCATION OF SKIPS, SEE READ STMTS BELOW
      NAMELIST/PAT1/TFON1,TFON2,TFSS,TFOFF3,TFOFF4,TFOFF5,DTRA2,WFCT,
     +AHXMLT,TMAFU,DTRA3,DTRA4,
     +N,BETA,TOLYR,DIFMIN,DLMIN,DSPMIN
      OPEN(60,FILE='TAPE60',STATUS='NEW',IOSTAT=IO60)
      IF(IO60.GT.0)THEN
        STOP ' CANT OPEN TAPE60 OUTPUT FILE'
      ENDIF
      OPEN(1,FILE='GASPAT',STATUS='OLD',IOSTAT=IO1)
      IF(IO1.NE.0) THEN
        WRITE(60,*)' CANT OPEN GASPAT INPUT FILE!!'
        STOP ' CANT OPEN GASPAT INPUT FILE'
        ENDIF
      OPEN(5,FILE='FURXX',STATUS='OLD',IOSTAT=IO5)
      IF(IO5.NE.0)THEN
        WRITE(60,*)' CANT OPEN FURXX INPUT FILE!!'
        STOP ' CANT OPEN FURNACE FURXX INPUT FILE!!'
        ENDIF
        
      DATA IAFUE/0/,IQFILE/0/
      DATA ICOND/0/
      DATA N/4/
      DATA NCTQ/'PITT','MPLS','NASH','CMH '/
      DATA QNACL,QNMPL,QNMJ/3*0./
      DATA QNMHX/3*0./
      DATA QNMSV/5*0./
C  PUT ICND FOR CONDENSING FURNACE
      RELH=0.
      READ(1,INPUT)
      READ(1,PAT1)
      IF(IQFILE.NE.0)THEN
        OPEN(2,FILE='Q1.OUT',STATUS='NEW',IOSTAT=IO2)
        IF(IO2.NE.0)THEN
          WRITE(60,*)' CANT OPEN Q1.OUT OUTPUT FILE'
          STOP ' CANT OPEN Q1.OUT OUTPUT FILE'
          ENDIF
        OPEN(3,FILE='Q2.OUT',STATUS='NEW',IOSTAT=IO3)
        IF(IO3.NE.0)THEN
          WRITE(60,*)' CANT OPEN Q2.OUT OUTPUT FILE'
          STOP ' CANT OPEN Q2.OUT OUTPUT FILE'
          ENDIF
        ENDIF
C  FIND THE FIRST STMT OF THE FURNACE FILE
    2 READ(5,539,END=91)NCTR
      DO 4 NCYQ=1,4
    4 IF(NCTR.EQ.NCTQ(NCYQ))GO TO 6
      GO TO 2
    6 READ(5,*)NSUBDV
      CALL RDSKP(0,NSK1)
      READ(5,*)NCELLS,IDAMP,IFAN,IOIL,IDIRCT,IH2O,ICL
      READ(5,*)(D(I),XL(I),AHX(I),HRAD(I),I=1,3)
      READ(5,*)CPM,RHOMT,BHX,AIN,AOUT,ADIL,DCELL,
     +         ZKBEND,WGMIN,PRTLD,DH2O,XLH2O,THG,QHINPT
      READ(5,*)(CPMV(I),RHOMVT(I),I=1,6)
      READ(5,*)DGAPHT,TOLDH,ZHX,ZA,ZAVB,ZAVH,ZAVA,ZVT
      READ(5,*)ZHX34,ZA14,AFCL
      READ(5,*)DVENT,(XV(I),I=1,5)
      READ(5,*)(EMIS(I),I=1,6)
      READ(5,*)XJ,ZKJ,CJ,RHOJ,AJ
      READ(5,*)APLEN,CPMPL,RHOMPL,HIPL1,HOPL1
      READ(5,*)EXCESS,FUELCM,CMFANP,WDPOW,QPILOT,REDH,PHI,PHIINF
      READ(5,*)(XF(I),I=1,12)
      CALL RDSKP(0,NSK2)
      READ(5,*)ECFMC1,ECFMC2,EFANPC
      READ(5,*)ECFMH1,EFANPH
      CALL RDSKP(0,NSK3)
      READ(5,*)DTIME
      WRITE(60,520)NCELLS
      WRITE(60,521)IDAMP,IFAN,IOIL,IDIRCT,IH2O,ICL
      WRITE(60,522)(D(I),XL(I),AHX(I),HRAD(I),I=1,3)
      WRITE(60,523)CPM,RHOMT,BHX,AIN,AOUT,ADIL,DCELL
      WRITE(60,524)ZKBEND,WGMIN,PRTLD,DH2O,XLH2O,THG,QHINPT
      WRITE(60,525)(CPMV(I),RHOMVT(I),I=1,6)
      WRITE(60,526)DGAPHT,TOLDH,ZHX,ZA,ZAVB,ZAVH
      WRITE(60,527)ZAVA,ZVT
      WRITE(60,528)ZHX34,ZA14,AFCL
      WRITE(60,529)DVENT,(XV(I),I=1,5)
      WRITE(60,530)(EMIS(I),I=1,6)
      WRITE(60,531)XJ,ZKJ,CJ,RHOJ,AJ
      WRITE(60,532)APLEN,CPMPL,RHOMPL,HIPL1,HOPL1
      WRITE(60,533)EXCESS,FUELCM,CMFANP,WDPOW,QPILOT,REDH,PHI,PHIINF
      WRITE(60,534)(XF(I),I=1,12)
      WRITE(60,536)ECFMC1,ECFMC2,EFANPC
      WRITE(60,537)ECFMH1,EFANPH
      WRITE(60,538)DTIME,TWBI,TI
      TCOMBS=TCOMB
      IF(RELH.GT.0.)THEN
C  GET TWBI AND WAIRHM
          IPSY=-3
          CALL PSY(IPSY,TCOMB,TWBI,TDUM,RELH,WAIRHM,HDUM)
      ELSE
C  GET WAIRHM
          IPSY=-1
          CALL PSY(IPSY,TCOMB,TWBI,TDUM,RDUM,WAIRHM,HDUM)
          ENDIF
      IOIL=1-IOIL
      DTIME=DTIME/(3600.*NSUBDV)
      CFM(1)=ECFMH1
      CFM(2)=ECFMC1
      U45=RHOAIR*60.
      WAIRFT=CFM(1)*U45*BARPSI/14.7
C  DTBLR IS DT DUE TO BLOWER AND MOTOR OPERATION
      DTBLR=3413.*EFANPH/(0.24*WAIRFT)
      TRETI=TRETP
      NATVNT=1
      IBRNSV=999
      ZASV=ZA
      ZA14SV=ZA14
      ZHXSV=ZHX
      ZHX34S=ZHX34
      IF(N.EQ.5)FANTFS=FANTOF
      TCYCNS=TCYCON
      NRDF1=0
      IF(TMAFU(3).GT.TIMEON)TMAFU(3)=TIMEON
      DTIM=60.*DTIME
      IQUIT=0
      NCYC=0
      NTCODE=0
      IF(TIMEON.EQ.0.)THEN
          NTCODE=1
          TIMEON=20.
          TIMEOF=20.
          ENDIF
   20 IQP=0
      NCYC=NCYC+1
      QNMIN=0.
      QNMOT=0.
      WRITE(60,504)TMSV,TJSV,TMACSV,TMPLSV,TMV
      IP=1
      TTP=0.
      IBURN1=0
      TT(1)=0.
   30 TCOMB=TCOMBS
      CALL GASF
      NRDF1=1
      IPLOT=IP+1
      TT(IPLOT)=TT(IP)+DTIM
      IF(IQUIT.EQ.1)THEN
          QUSE(IPLOT)=QUSEFL
          QINP(IPLOT)=QINPUT
          QSLOS(IPLOT)=QVSLOS
          QLLOS(IPLOT)=QVLLOS
      IF(INDQ(1).EQ.1)THEN
          DO 40   I=1,3
   40     QMHXT(IPLOT,I)=QMHX(I)
          ENDIF
      IF(INDQ(2).EQ.1)THEN
          QACLT(IPLOT)=QACL
          ENDIF
      IF(INDQ(5).EQ.1)THEN
          QMJT(IPLOT)=QMJ
          ENDIF
      IF(INDQ(3).EQ.1)THEN
          QMPLT(IPLOT)=QMPL
          ENDIF
      IF(INDQ(4).EQ.1)THEN
          DO 50 I=1,5
   50     QMSVT(IPLOT,I)=QMSV(I)
          ENDIF
          ENDIF
      TTP=TTP+IBURN1*DTIM
      IF(WD.LT.0..AND.IQUIT.EQ.1)WRITE(60,591)TTP,WD,QDRAFT
      IF(IEFAN.EQ.0)TRETP=TRETI
      IF(IEFAN.EQ.1)TRETP=TRETI+DTBLR
      IF(IDEBUG.NE.0)WRITE(60,508)TT(IPLOT),QVSLOS,QVLLOS
      IF(IBURN.EQ.1.AND.TT(IPLOT).GE.TIMEON)THEN
          TTP=0.
          IBURN=0
          IBURN1=1
          EFFYSS=(QEXT-(QVSLOS+QVLLOS))/QEXT*100.
          WRITE(60,505)TT(IPLOT),QVSLOS,QVLLOS,EFFYSS
          QPLENC=QPLEN*NCELLS
          QJACKC=QJACK*NCELLS
          WRITE(60,514)QPLENC,QJACKC
          QOUT=WAIRFT*.24*(DTRA2C-DTBLR)+QPLENC+QJACKC
          EFFYSQ=QOUT*100./QEXT
          EFFYSJ=(QOUT-QJACKC)*100./QEXT
          WRITE(60,516)EFFYSQ,EFFYSJ
          IF(ICOND.GT.0)WRITE(60,517)QNMIN,QNMOT
          QINN=EFFYSS*.01*QEXT
          PCTQ=(QINN-QOUT)*100./QINN
          SCFMQ=(.01*EFFYSS*QEXT-QPLENC-QJACKC)*14.7
     +    /(60.*.075*BARPSI*.24*(DTRA2C-DTBLR))
          WRITE(60,515)QOUT,QINN,PCTQ,SCFMQ
          ENDIF
      IF(IBURN.NE.IBRNSV.AND.IQP.NE.0)THEN
          WRITE(60,503)TT(IPLOT),TAHX,TJ,TAAC,TMAC,TA2,TMPL,TPL
          IQP=1
          ENDIF
      IF(IBRNSV.EQ.IBURN.AND.IBURN.EQ.0)THEN
          IF(TTP.GE.TIMEOF)GO TO 80
          ENDIF
      IBRNSV=IBURN
C- - - -
      IP=IP+1
      IF(IP.GT.299)THEN
          IPLOT=300
          IP=299
          ENDIF
      GO TO 30
C - - - -
C  REACHED END OF "OFF" CYCLE
   80 IF(ICOND.EQ.1)WRITE(60,517)QNMIN,QNMOT
      IF(IQUIT.EQ.0)THEN
          IF(NCYC.EQ.(NCYCLS-1))THEN
              IQUIT=1
              IDEBUG=500
              ENDIF
          ISKIP=0
C  PUT IDEBUG = 500 BELOW TO GET PRINT FROM PLENUM AND QVSLOS AND QVLLOS
C  SET FIRST VALUE OF Q'S TO USE FOR START OF FINAL PASS
          QUSE(1)=QUSEFL
          QINP(1)=QINPUT
          QSLOS(1)=QVSLOS
          QLLOS(1)=QVLLOS
          IF(INDQ(2).EQ.1)QACLT(1)=QACL
          IF(INDQ(5).EQ.1)QMJT(1)=QMJ
          IF(INDQ(3).EQ.1)QMPLT(1)=QMPL
          DO 82 I=1,5
          IF(INDQ(1).EQ.1)THEN
              IF(I.LE.3)QMHXT(1,I)=QMHX(I)
              ENDIF
          IF(INDQ(4).EQ.1)QMSVT(1,I)=QMSV(I)
   82     CONTINUE
          GO TO 20
          ENDIF
C
      WRITE(60,506)EFFYSS
      QPLENC=QPLEN*NCELLS
      QJACKC=QJACK*NCELLS
      WRITE(60,514)QPLENC,QJACKC
C  CALC EFFCY FOR TRANSIENT OPERATION
      IPLT=IPLOT
      IF(IQFILE.EQ.1)THEN
      DO 90 I=1,IPLT
      WRITE(2,511)TT(I),QINP(I),QUSE(I),QSLOS(I),QLLOS(I)
      WRITE(3,513)TT(I),(QMHXT(I,J),J=1,3),QACLT(I),QMPLT(I),
     +QMSVT(I,1),(QMSVT(I,J),J=3,5),QMJT(I)
   90 CONTINUE
          ENDIF
      CALL FEFFCY(QNUSEF,QNINPT,QNSTKL,EFFFUR,EFFSTK)
      WRITE(60,507)QNUSEF,QNINPT,QNSTKL,EFFFUR,EFFSTK
      IF(ICOND.EQ.1)WRITE(60,517)QNMIN,QNMOT
      CALL FQNTY(QNMHX,QNACL,QNMPL,QNMSV,QNMJ)
      WRITE(60,512)(QNMHX(I),I=1,3),QNACL,QNMPL,(QNMSV(I),I=1,5),
     +QNMJ
      DTFON1=TFON1C-TFON1
      DTFON2=TFON2C-TFON2
      DTFSS=TFSSC-TFSS
      DTFOF3=TFFF3C-TFOFF3
      DTFOF4=TFFF4C-TFOFF4
      DTFOF5=TFFF5C-TFOFF5
      DTDTA2=DTRA2C-DTRA2
      DTDTA3=DTRA3C-DTRA3
      DTDTA4=DTRA4C-DTRA4
      WRITE(60,509)TFON1C,TFON2C,TFSSC,TFFF3C,TFFF4C,TFFF5C,
     +DTRA2C,DTRA4C,DTRA3C,TFON1,TFON2,TFSS,TFOFF3,TFOFF4,TFOFF5,
     +DTRA2,DTRA4,DTRA3,DTFON1,DTFON2,DTFSS,DTFOF3,DTFOF4,DTFOF5,
     +DTDTA2,DTDTA4,DTDTA3
      ZA=ZASV
      ZA14=ZA14SV
      ZHX=ZHXSV
      ZHX34=ZHX34S
      IF(N.EQ.5)FANTOF=FANTFS
      TCYCON=TCYCNS
      WRITE(60,503)TT(IPLOT),TAHX,TJ,TAAC,TMAC,TA2,TMPL,TPL
      WRITE(60,504)TMSV,TJSV,TMACSV,TMPLSV,TMV
      IF(NTCODE.EQ.1)THEN
C    - -  NOW COMPUTE AFUE CYCLE(TIMEON,TIMEOF FOR PITTSBURGH)
          IF(IAFUE.EQ.0)GO TO 999
          ISKIP=0
          TIMEON=3.87
          TIMEOF=13.3
          IQUIT=0
          NTCODE=0
          NCYC=0
          IDEBUG=0
          GO TO 20
          ENDIF
      GO TO 999
   91 STOP 'HIT EOF SEARCHING FOR CITY NAME!!!'
  999 CONTINUE
      STOP 'ENDED OK!!!'
  500 FORMAT(1X,'NTW,TFOFF5,TFFF5C,PHIINF= ',I5,3G13.5)
  501 FORMAT(1X,'TFFF5C WONT CONVERGE TO TFOFF5')
  502 FORMAT(1H ,'IPLOT= ',I5/(1X,2G13.5/))
  503 FORMAT(1X,' VALUES AT START OR END OF PERIOD'/
     +1X,' TIME,TA2,TJ,TA2,TMAC,TA2,TMPL,TPL= '/1X,8G13.5)
  504 FORMAT(1X,' TMSV= ',3G13.5/
     +1X,' TJSV,TMACSV,TMPLSV= ',3G13.5/
     +1X,' TMV= ',5G13.5)
  505 FORMAT(1H0,'TIME,QVSLOS,QVLLOS,EFFYSS= ',F12.5,4G13.5)
  506 FORMAT(1X,'STEADY-STATE FURNACE EFFCY= ',F6.2)
  507 FORMAT(1X,'QNUSEF= ',G13.5/1X,'QNINPT= ',G13.5/
     +1X,'QNSTKL= ',G13.5//
     +1X,'FURNACE EFFCY FOR TRANSIENT CYCLE'/
     +15X,'BASED ON ENERGY DELIVERED= ',F6.2/
     +15X,'BASED ON STACK LOSS METHOD=',F6.2)
  508 FORMAT(1X,'TIME,QVSLOS,QVLLOS= ',F12.5,2G13.5)
  509 FORMAT(1H0,3X,'TFON1',8X,'TFON2',8X,'TFSS',8X,'TFOF3',8X,
     +'TFOF4',8X,'TFOF5',8X,'DTRA2',8X,'DTRA4',8X,'DTRA3'/
     +1X,9G13.5/1X,9G13.5/1X,9G13.5)
  510 FORMAT(1X,'REACHED EOF WHEN SKIPPING STMTS ON TAPE5')
  511 FORMAT(1X,F12.5,4E13.7)
  512 FORMAT(1X,'QNMHX(1-3)= ',3G15.7/
     +1X,'QNACL= ',G15.7/
     +1X,'QNMPL= ',G15.7/
     +1X,'QNMSV(1-5)= ',5G15.7/
     +1X,'QNMJ= ',5G15.7)
  513 FORMAT(1X,F12.5,11E11.4)
  514 FORMAT(1X,'QPLENC,QJACKC= ',2G13.5)
  515 FORMAT(1X,'QOUT,QINN,PCTQ,SCFMQ= ',4G13.5)
  516 FORMAT(1X,'STEADY-STATE EFFCY(AIR SIDE)= ',G13.5/
     +1X,'SS EFFCY (LESS JACKET LOSS)= ',G13.5)
  517 FORMAT(1X,'HEAT INTO HXMTL= ',G13.5,
     +1X,'HEAT OUT OF HXMTL= ',G13.5)
  520 FORMAT(1H1,'NCELLS= ',I5)
  521 FORMAT(1X,'IDAMP,IFAN,IOIL,IDIRCT,IH2O,ICL= ',6I5)
  522 FORMAT(1X,3(' D,XL,AHX,HRAD= ',4G13.5/))
  523 FORMAT(1X,'CPM,RHOMT,BHX,AIN= ',4G13.5/
     +1X,'AOUT,ADIL,DCELL= ',3G13.5)
  524 FORMAT(1X,'ZKBEND,WGMIN,PRTLD= ',3G13.5/
     +1X,'DH2O,XLH2O,THG,QHINPT= ',4G13.5)
  525 FORMAT(6(' CPMV,RHOMVT= ',2G13.5/))
  526 FORMAT(1X,'DGAPHT,TOLDH= ',2G13.5/
     +1X,'ZHX,ZA,ZAVB,ZAVH= ',4G13.5)
  527 FORMAT(1X,'ZAVA,ZVT= ',2G13.5)
  528 FORMAT(1X,'ZHX34,ZA14,AFCL= ',3G13.5)
  529 FORMAT(1X,'DVENT= ',G13.5,' XV= ',5G13.5)
  530 FORMAT(1X,'EMIS= ',6G13.5)
  531 FORMAT(1X,'XJ,ZKJ,CJ,RHOJ,AJ= ',5G13.5)
  532 FORMAT(1X,'APLEN,CPMPL,RHOMPL,HIPL1,HOPL1= ',5G13.5)
  533 FORMAT(1X,'EXCESS,FUELCM,CMFANP= ',3G13.5/
     +1X,'WDPOW,QPILOT,REDH= ',3G13.5/
     +1X,'PHI,PHIINF= ',2G13.5)
  534 FORMAT(1X,'XF= ',6G13.5/1X,'XF= ',6G13.5)
  536 FORMAT(1X,'ECFMC1,ECFMC2,EFANPC= ',3G13.5)
  537 FORMAT(1X,'ECFMH1,EFANPH= ',2G13.5)
  538 FORMAT(1X,'DTIME,TWBI= ',2G13.5/
     + 1X,' TI= ',5G13.5)
  539 FORMAT(A4)
  591 FORMAT(1H ,1X,'TIME,WD,QDRAFT= ',F12.5,2G13.5)
      END
      SUBROUTINE QSUM(TM1,TM2,NINTG,E)
C
C  USE SIMPSONS ONE-THIRD RULE TO GET BTU
C  TM1  EARLY TIME,HR
C  TM2  LATER TIME,HR
C  NINTG  NO. OF INTEG STEPS
C  E,BTU
C
      DTM=(TM2-TM1)/NINTG
      E1=QFUNC(TM1)
      E2=QFUNC(TM2)
      E=E1+E2
      IMX=NINTG-1
      DO 10 I=1,IMX,2
   10 E=E+4.*QFUNC(TM1+I*DTM)
      IMY=NINTG-2
      DO 20 I=2,IMY,2
   20 E=E+2.*QFUNC(TM1+I*DTM)
      E=DTM*E/3.
      RETURN
      END
      FUNCTION SEK1(ARG,ISTOP)
C
C  TABLE LOOKUP.  EXECUTION TIME REDUCED BY REMEMBERING LOCATION OF
C   PREV LOOKUP(J2). INDEP PAR MUST INCREASE WITH INCREASING J, WHERE
C   J MAY BE 1 TO 30 VALUES.
C  SOURCE::: GALE WHITACRE,BATTELLE
C
C  ARG    VALUE OF INDEP PAR
C  ISTOP  PROGRAM STOP PAR (IF=1,TROUBLE IN LOOKUP)
C  NVAL   NO. OF TABULAR VALUES
C  ARGX   INDEP PAR TABLE
C  ARGY   DEP PAR TABLE
C
      COMMON/BLKSEK/NVAL,ARGX(300),ARGY(300)
      DATA J2/1/
      ISTOP=0
      MLAST=NVAL
      IF(J2.GT.MLAST)J2=MLAST
      J1=J2
      XB1=ARGX(J1)
   10 IF(ARG-XB1)20,30,40
   20 IF(J1.LE.1)GO TO 80
      J1=J1-1
      XB1=ARGX(J1)
      GO TO 10
   30 SEK1=ARGY(J1)
      RETURN
C
   40 IF(J1-MLAST)50,70,90
   50 IF(XB1-ARG)60,30,70
   60 J1=J1+1
      XB1=ARGX(J1)
      GO TO 40
C
   70 J2=J1-1
      XB=ARGX(J2)
      YB2=ARGY(J2)
      YBQ=ARGY(J1)
      SEK1=YB2+(YBQ-YB2)*(ARG-XB)/(XB1-XB)
      IF((XB1-ARG).GE.0.)RETURN
      PRINT 500,ARG
      ISTOP=1
      RETURN
   80 PRINT 510,ARG
      ISTOP=1
      RETURN
   90 PRINT 520,ARG
      ISTOP=1
      RETURN
  500 FORMAT(1H0,5X,'SEK1 STOP-EXCEEDS MAX TABLE VALUE.',
     +' ARG= ',G13.5)
  510 FORMAT(1H0,5X,'SEK1 STOP-ARG IS LESS THAN MIN TABLE VALUE.',
     +' ARG= ',G13.5)
  520 FORMAT(1H0,5X,'SEK1 STOP-J IS GREATER THAN MLAST.',
     +' J,MLAST,ARG= ',3I5,G13.5)
      END
      SUBROUTINE FEFFCY(QNUSEF,QNINPT,QNSTKL,EFFFUR,EFFSTK)
C
C  CALC EFFCY DURING AFUE PITTSBURGH CYCLE
C
      COMMON/BLK8/IPLOT,QUSE(300),QINP(300),QSLOS(300),QLLOS(300)
      COMMON/BLK9/TT(300)
      COMMON/BLK2/NOP,NT
      DATA NINTG/200/
      NT=0
      TM1=TT(1)
      TM2=TT(IPLOT)
      NOP=1
      CALL QSUM(TM1,TM2,NINTG,QNUSEF)
      NOP=2
      CALL QSUM(TM1,TM2,NINTG,QNINPT)
      NOP=3
      CALL QSUM(TM1,TM2,NINTG,QNSTKL)
      EFFFUR=100.*QNUSEF/QNINPT
      EFFSTK=100.*(1.-QNSTKL/QNINPT)
      RETURN
      END
      FUNCTION QFUNC(TIM)
C
C  LOOKUP DATA
      DIMENSION QLOST(300),QPAR(300)
      COMMON/BLK8/IPLOT,QUSE(300),QINP(300),QSLOS(300),QLLOS(300)
      COMMON/BLK9/TT(300)
      COMMON/BLK88/QMHXT(300,3),QACLT(300),QMPLT(300),QMSVT(300,5)
     +,QMJT(300)
      COMMON/BLKSEK/NVAL,ARGX(300),ARGY(300)
      COMMON/BLK2/NOP,NT
      IF(NT.EQ.0)THEN
      DO 10 I=1,IPLOT
      ARGX(I)=TT(I)
   10 QLOST(I)=QSLOS(I)+QLLOS(I)
      NVAL=IPLOT
      ENDIF
      IF(NOP.EQ.14)GO TO 140
      IF(NOP.EQ.13)GO TO 130
      IF(NOP.EQ.12)GO TO 120
      IF(NOP.EQ.11)GO TO 110
      IF(NOP.EQ.10)GO TO 100
      IF(NOP.EQ.9)GO TO 90
      IF(NOP.EQ.8)GO TO 80
      IF(NOP.EQ.7)GO TO 70
      IF(NOP.EQ.6)GO TO 60
      IF(NOP.EQ.5)GO TO 50
      IF(NOP.EQ.4)GO TO 40
      IF(NOP.EQ.3)GO TO 30
      IF(NOP.EQ.2)GO TO 20
      CALL SETY(TIM,1,QUSE,QF)
      GO TO 200
   20 CALL SETY(TIM,2,QINP,QF)
      GO TO 200
   30 CALL SETY(TIM,3,QLOST,QF)
      GO TO 200
   40 DO 42 I=1,IPLOT
   42 QPAR(I)=QMHXT(I,1)
      CALL SETY(TIM,4,QPAR,QF)
      GO TO 200
   50 DO 52 I=1,IPLOT
   52 QPAR(I)=QMHXT(I,2)
      CALL SETY(TIM,5,QPAR,QF)
      GO TO 200
   60 DO 62 I=1,IPLOT
   62 QPAR(I)=QMHXT(I,3)
      CALL SETY(TIM,6,QPAR,QF)
      GO TO 200
   70 CALL SETY(TIM,7,QACLT,QF)
      GO TO 200
   80 CALL SETY(TIM,8,QMPLT,QF)
      GO TO 200
   90 DO 92 I=1,IPLOT
   92 QPAR(I)=QMSVT(I,1)
      CALL SETY(TIM,9,QPAR,QF)
      GO TO 200
  100 DO 102 I=1,IPLOT
  102 QPAR(I)=QMSVT(I,2)
      CALL SETY(TIM,10,QPAR,QF)
      GO TO 200
  110 DO 112 I=1,IPLOT
  112 QPAR(I)=QMSVT(I,3)
      CALL SETY(TIM,11,QPAR,QF)
      GO TO 200
  120 DO 122 I=1,IPLOT
  122 QPAR(I)=QMSVT(I,4)
      CALL SETY(TIM,12,QPAR,QF)
      GO TO 200
  130 DO 132 I=1,IPLOT
  132 QPAR(I)=QMSVT(I,5)
      CALL SETY(TIM,13,QPAR,QF)
      GO TO 200
  140 CALL SETY(TIM,14,QMJT,QF)
  200 QFUNC=QF
      RETURN
      END
      SUBROUTINE RDSKP(IOPT,N)
C
C  SKIP RECORDS
      CHARACTER*3 NH,NHSTP
      DATA NHSTP/'CMH'/
      IF(IOPT.EQ.1)GO TO 20
      NT=0
   10 NT=NT+1
      IF(NT.GT.N)RETURN
      READ(5,500)NH
      GO TO 10
   20 READ(5,500,END=999)NH
      IF(NH.EQ.NHSTP)RETURN
      GO TO 20
  999 WRITE(60,501)
      STOP
  500 FORMAT(A3)
  501 FORMAT(1X,'---HIT EOF WHEN SKIPPING IN RDSKP')
      END
      SUBROUTINE SETY(TIM,NI,Q,QFUNC)
C
C  SET ARGY FOR INTEGRATION
      COMMON/BLK2/NOP,NT
      COMMON/BLKSEK/NVAL,ARGX(300),ARGY(300)
      DIMENSION Q(300)
      DATA NQ/0/
      IF  (NT.EQ.NI)GO TO 20
      DO 10 I=1,NVAL
   10 ARGY(I)=Q(I)
      NT=NI
   20 QFUNC=SEK1(TIM,ISTOP)
      IF(ISTOP.EQ.1)THEN
      NQ=NQ+1
      IF(NQ.LT.50)WRITE(60,500)TIM,NT
      ENDIF
      RETURN
  500 FORMAT(1X,'- - OOPS,TABLE LOOKUP BAD,TIM,NT= ',F12.5,I5)
      END
      SUBROUTINE FQNTY(QNMHX,QNACL,QNMPL,QNMSV,QNMJ)
C
C  INTEGRATE STORAGE Q S
      COMMON/BLK2/NOP,NT
      COMMON/BLK8/IPLOT,Q1(300),Q2(300),Q3(300),Q4(300)
      COMMON/BLK9/TT(300)
      COMMON/INDQB/INDQ(5)
      DIMENSION QNMHX(3),QNMSV(5)
C  INDQ(1) FOR QMHX'S
C  INDQ(2) FOR QMACL
C  INDQ(3) FOR QMPL
C  INDQ(4) FOR QMVENT'S
C  INDQ(5) FOR QMJACK
      DATA NINTG/200/
      TM1=TT(1)
      TM2=TT(IPLOT)
      IF(INDQ(1).EQ.1)THEN
          NOP=3
          DO 10 I=1,3
          NOP=NOP+I
          CALL QSUM(TM1,TM2,NINTG,QNMHX(I))
   10     CONTINUE
          ENDIF
      IF(INDQ(2).EQ.1)THEN
          NOP=7
          CALL QSUM(TM1,TM2,NINTG,QNACL)
          ENDIF
      IF(INDQ(3).EQ.1)THEN
          NOP=8
          CALL QSUM(TM1,TM2,NINTG,QNMPL)
          ENDIF
      IF(INDQ(4).EQ.1)THEN
          NOP=8
          DO 20 I=1,5
          NOP=NOP+1
          IF(I.EQ.2)THEN
              QNMSV(I)=0.
              GO TO 20
              ENDIF
          CALL QSUM(TM1,TM2,NINTG,QNMSV(I))
   20     CONTINUE
          ENDIF
      IF(INDQ(5).EQ.1)THEN
          NOP=14
          CALL QSUM(TM1,TM2,NINTG,QNMJ)
          ENDIF
      RETURN
      END
      BLOCK DATA
CMDK NZN      
CMDK BLK81      
CMDK BLK83
CMDK BLK87
      COMMON/BLK88/QMHXT(300,3),QACLT(300),QMPLT(300),QMSVT(300,5)
     +,QMJT(300)
CMDK COLCT     
CMDK DTRQ
CMDK GASFC
CMDK BLKGS1
CMDK BLKGS2
CMDK INDIC1
CMDK BLKOIL
CMDK BLKQGS
CMDK TIMEB
CMDK TEMP1      
      COMMON/INDQB/INDQ(5)
CMDK OILB      
CMDK PRT1
      DATA BARPSI/14.7/
      DATA FANTOF/0./
      DATA HAACL/0.,0./
      DATA IAC1/1/
      DATA IHON/0/
      DATA INDQ/5*0/
      DATA IRGSF/0/
      DATA PUMPW/0./
      DATA QACL/0./
      DATA QMSV/5*0./
      DATA QMSVT/1500*0./
      DATA SOOT/1./
      DATA TFLUE/470./
      DATA THETA/0./
      DATA TIMEON,TIMEOF/0.,0./
      DATA TJSV/73./
      DATA TMACSV/93./
      DATA TMAFU/.5,1.5,20.,1.5,9.,999./
      DATA TMPLSV/76./
      DATA TMSV/105.,123.,133./
      DATA TRAREF/0./
      DATA TVENTI/305./
      DATA XM/0./
      END
