C      PROGRAM LST
C
C   LIST PART OF FILE
C  TAPES:  TAPE1  INPUT FILE TO LIST A PORTION FROM
C          TAPE5  INPUT FILE FOR CONTROLLING LST EXECUTION
C          TAPE2  OUTPUT FILE OF LISTED INFO
      CHARACTER*10 NA(8),NB(130),FILEIN,FILEOT
      DIMENSION NCHI(2)
C  LINSKP  NO. OF LINES TO SKIP AT FRONT OF FILE
C  NLINES  NO. OF LINES TO LIST
C  NCHAR  NO. OF CHARACTERS/LINE  (80 OR 132)
C  LININT  NO. OF SPACES BETWEEN LINES
C  IONSPC =0 FOR NO SPACES AT COL 1, =1 FOR 1 SPC IN COL 1
C      NAMELIST/INP/LINSKP,NLINES,NCHAR,LININT
C      DATA LINSKP,NCHAR,LININT/0,80,1/
      OPEN(5,FILE='LST.DAT',STATUS='OLD')
      DATA NCHI/80,132/
      READ(5,*,END=97)LINSKP,NLINES,NCHAR,LININT,IONSPC
      READ(5,516)FILEIN,FILEOT
      PRINT 515,LINSKP,NLINES,NCHAR,LININT,IONSPC
      PRINT 514,FILEIN,FILEOT 
      OPEN(1,FILE=FILEIN,STATUS='OLD')
      OPEN(2,FILE=FILEOT,STATUS='UNKNOWN')
      DO 10 I=1,2
   10 IF(NCHAR.EQ.NCHI(I))GO TO 20
      STOP 'NCHAR INPUT MUST BE 80 OR 132'
   20 IF(NCHAR.EQ.80)THEN
          IF(LINSKP.NE.0)THEN 
              DO 30 I=1,LINSKP
   30         READ(1,500)NA
              ENDIF 
          DO 40 I=1,NLINES
          READ(1,500,END=98)NA
          IF(LININT.EQ.1)THEN 
	     IF(IONSPC.EQ.1)WRITE(2,501)NA
            IF(IONSPC.EQ.0)WRITE(2,500)NA
          ELSE
              IF(LININT.EQ.2)THEN
                  WRITE(2,504)
                  IF(IONSPC.EQ.1)WRITE(2,501)NA
		    IF(IONSPC.EQ.0)WRITE(2,500)NA
              ELSE
                  DO 38 J=2,LININT
   38             WRITE(2,504)
                  IF(IONSPC.EQ.1)WRITE(2,501)NA
		    IF(IONSPC.EQ.0)WRITE(2,500)NA
                  ENDIF
              ENDIF 
   40     CONTINUE
          ENDIF
      IF(NCHAR.EQ.132)THEN
          IF(LINSKP.NE.0)THEN 
              DO 50 I=1,LINSKP
   50         READ(1,502)NB,NC
              ENDIF 
          DO 60 I=1,NLINES
          READ(1,502,END=99)NB,NC
          IF(LININT.EQ.1)THEN 
              IF(IONSPC.EQ.1)WRITE(2,503)NB,NC
		IF(IONSPC.EQ.0)WRITE(2,502)NB,NC
          ELSE
              IF(LININT.EQ.2)THEN
                  WRITE(2,504)
                  IF(IONSPC.EQ.1)WRITE(2,503)NB,NC
		    IF(IONSPC.EQ.0)WRITE(2,502)NB,NC
              ELSE
                  DO 58 J=2,LININT
   58             WRITE(2,504)
                  IF(IONSPC.EQ.1)WRITE(2,503)NB,NC
		    IF(IONSPC.EQ.0)WRITE(2,502)NB,NC
                  ENDIF
              ENDIF 
   60     CONTINUE
          ENDIF
      STOP 'ENDED OK'
   97 STOP 'EOF ON READ OF INP IN LST'
   98 STOP 'EOF ON 80 CHAR READ IN LST' 
   99 STOP 'EOF ON 132 CHAR READ IN LST'
  500 FORMAT(8A10)
  501 FORMAT(1X,8A10)
  502 FORMAT(13A10,A2)
  503 FORMAT(1X,13A10,A2)
  504 FORMAT(1H )
  505 FORMAT(1H1)
  506 FORMAT(1H0,8A10)
  507 FORMAT(1H0,13A10,A2)
  514 FORMAT(1X,'INPUT/OUTPUT FILES= ',A10,2X,A10)
  515 FORMAT(1X,'LINSKP,NLINES= ',2I5/
     +' NCHAR,LININT,IONSPC= ',3I5)
  516 FORMAT(2A10)
      END 
/